<template>
    <section class="ois-page">
        <div class="container" v-if="$store.state.ois.loader">
            <h1 class="ois-title center">Загрузка...</h1>
        </div>
        <div class="container" v-if="!$store.state.ois.loader">
            <!-- Стандартный функционал, при загрузке списка ois (если у пользователя есть что-то из списка) -->
            <div :class="[listOIS.length ? 'ois-top space-between' : 'ois-bottom']">
                <h1 class="ois-title">Мои ОИС</h1>
                <div class="space-between" v-if="listOIS.length">
                    <base-button text="КУПИТЬ ОИС"
                                       class="btn-primary"
                                       size="220px"
                                       style="margin: 0 25px 25px 0"
                                       @click.native="$router.push('sell-ois')" />
                    <div class="sort-panel">
                        <div @click="type = 'list'" class="button-section">
                            <div :class="[{'active': type === 'list'}]">
                                <div class="button-section__list"></div>
                                <div class="button-section__list"></div>
                                <div class="button-section__list"></div>
                                <div class="button-section__list"></div>
                            </div>
                        </div>
                        <div @click="type = 'blocks'" class="button-section">
                            <div class="button-section_blocks" :class="[{'active': type === 'blocks'}]">
                                <div class="button-section_block"></div>
                                <div class="button-section_block"></div>
                                <div class="button-section_block"></div>
                                <div class="button-section_block"></div>
                            </div>
                        </div>
                        <div @click="callFilter" class="button-filter">
                            <div class="button-filter__icon"></div>
                        </div>
                    </div>
                </div>

                <!-- На момент, когда на странице нету ни одного пункта из списка -->

                <div v-if="!listOIS.length" class="ois-section-empty">
                    <p class="ois-section-empty__text">Вы пока не добавили ни один ОИС.</p><br/>
                    <p class="ois-section-empty__text">Загрузите ваш первый ОИС<br>или приобретите на бирже.</p>
                    <div class="ois-button__wrapper center">
                        <div class="ois-button__wrapper-block">
                            <base-button text="КУПИТЬ ОИС"
                                         class="btn-primary"
                                         size="295px"
                                         style="margin-bottom: 25px"
                                         @clickButton="$router.push('/ois')" />
                            <base-button text="Добавить ОИС"
                                         class="btn-orange"
                                         size="295px"
                                         @clickButton="$router.push('/ois/upload')" />
                        </div>
                    </div>
                </div>

            </div>

            <!-- //TODO Раздел фильтра (на данный момент не согласован, будет ли он вообще) -->

<!--                <filter-panel></filter-panel>-->

            <!-- Раздел в виде списка -->

            <section v-if="listOIS.length && type === 'list'" class="ois-section-list">

                <section class="ois-list-head align-center">
                    <div class="ois-list-head__img"></div>
                    <div class="ois-list-head__title flex">
                        Название ОИС
                        <div class="ois-sort">
                            <div class="up"></div>
                            <div class="down"></div>
                        </div>
                    </div>
                    <div class="ois-list-head__type flex">
                        Тип
                        <div class="ois-sort">
                            <div class="up"></div>
                            <div class="down"></div>
                        </div>
                    </div>
                    <div class="ois-list-head__date align-center">
                        Дата размещения
                        <div class="ois-sort">
                            <div class="up"></div>
                            <div class="down"></div>
                        </div>
                    </div>
                    <div class="ois-list-head__status">Статус</div>
                    <div class="ois-list-head__ipchain">IPChain ID</div>
                    <div class="ois-list-head__params"></div>
                </section>

                <section class="ois-items" v-for="item in listOIS" :key="item.id" @click="$router.push(item.status ? `ois/${item.id}` : `ois/upload?ipchainID=${item.id}`)">
                    <div class="ois-items__img align-center" :key="item.id">
                        <img :src="item.img" :alt="item.name" v-if="item.img">
                        <div :class="[['3D модель', 'Изображение'].includes(item.type) ? 'image' : 'music']" v-else></div>
                    </div>
                    <div class="ois-items__title" :class="[item.status === 2 ? 'red' : '']">{{item.name}}</div>
                    <div class="ois-items__description type">
                        {{item.type}} <div>{{item.description}}</div>
                    </div>
                    <div class="ois-items__description date center">{{transformDate(item.created)}}</div>
                    <div class="ois-items__status">
                        <div class="status" :class="[getClass(item.status)]"></div>
                    </div>
                    <div class="ois-items__ipchain">
                        <a :href="`https://demo.ipchain.ru/network/sight/object/?id=${item.id}&channel=${item.channel_id}`"  target="_blank">
                            {{getIpchainId(item.id, item.status)}}
                        </a>
                    </div>
                    <div class="ois-items__params">
                        <div class="block" :class="[item.censure ? 'censure' : '']"></div>
                        <div class="block" :class="[item.adult ? 'adult' : '']"></div>
                        <div class="star" :class="[item.star ? ' star-on' : ' star-off']"></div>
                    </div>
                </section>

            </section>

            <!-- Раздел в виде карточек -->

            <section class="ois-section-block" v-if="listOIS.length && type === 'blocks'">
                <section class="ois-blocks" v-for="item in listOIS" :key="item.id" @click="$router.push(item.status ? `ois/${item.id}` : `ois/upload?ipchainID=${item.id}`)">
                    <div class="ois-items__block-image">
                        <div class="ois-card__params space-between">
                            <div class="star" :class="[item.star ? ' star-on' : ' star-off']"></div>
                            <div class="block-flag">
                                <div class="flag" :class="[item.censure ? 'censure' : '']"></div>
                                <div class="flag" :class="[item.adult ? ' adult' : '']"></div>
                            </div>
                        </div>
                        <img :src="item.img" :alt="item.name" class="ois-blocks__img" v-if="item.img">
                        <div :class="[['3D модель', 'Изображение'].includes(item.type) ? 'ois-items__image' : 'ois-items__music']" v-else></div>
                        <div class="ois-card__status">
                            <div class="status" :class="[getClass(item.status)]"></div>
                        </div>
                    </div>
                    <div class="ois-blocks__info">
                        <div class="ois-blocks__title">{{item.name}}</div>
                        <div class="ois-blocks__type">{{item.type}} <div>{{item.description}}</div></div>
                        <div class="ois-blocks__author">{{item.author}}</div>
                    </div>
                </section>
            </section>

        </div>
    </section>
</template>

<script>
export default {
    name: 'list-ois',
    // components: { FilterPanel: () => import('pages/Ois/FilterPanel') },
    layout: 'layout-detail',
    data() {
        return {
            type: 'list' // list OR blocks
        };
    },
    async created() {
        await this.$store.dispatch('ois/getListCandidates');
    },
    computed: {
        listOIS() {
            let list = [];
            let arr = this.$store.state.ois.list;
            arr.forEach(key => {
                if (Array.isArray(key)) {
                    for (let our in key) {
                        list.push(key[our]);
                    }
                } else {
                    for (let i in key) {
                        for (let l in key[i]) {
                            for (let m in key[i][l]) {
                                list.push(key[i][l][m]);
                            }
                        }
                    }
                }
            });
            return list;
        }
    },
    methods: {
        getClass(styles) {
            switch (styles) {
                case 1:
                    return 'pending';
                case 2:
                    return 'resolve';
                case 3:
                    return 'reject';
                case undefined:
                    return 'not-catalog';
                case 'ipchain':
                    return 'ipchain';
                default:
                    return '';
            }
        },
        transformText(text) { // пока функция не используется, но предназчена для работы с массивом и включение первой загловной буквы
            if (text.length) {
                text = text.join('');
                text = text.charAt(0).toUpperCase() + text.substr(1);
                return text;
            }
            return '';
        },
        transformDate(date) {
            if (date !== undefined && date.length) {
                date = this.$dayjs(date).format('DD-MM-YYYY');
                return date;
            }
            return '';
        },
        getIpchainId(id, status) {
            if (status === undefined) {
                id = id.length > 17 ? id = id.slice(0, 8) + ' ... ' + id.slice(id.length - 8, id.length) : id;
                return id;
            } else {
                return '';
            }
        },
        callFilter() {
            alert('Фильтер еще не согласован');
        }
    }
};
</script>

<style scoped lang="sass">

</style>
